import es
from es import server_var
import gamethread
import time
import ConfigParser

config = ConfigParser.RawConfigParser()
config.read(server_var["eventscripts_gamedir"] + '/cfg/sprint.ini')

sprint_time = int(config.get("Sprint", "time"))
sprint_cooldown = int(config.get("Sprint", "cooldown"))
sprint_speed = int(config.get("Sprint", "speed"))
sprint_msgs = int(config.get("Sprint", "msgs"))

def load():
  es.set('xsprint_version', '2.00')
  es.makepublic('xsprint_version')
  es.msg('#Green', 'Sprint Script On - by Toph')
  loadblock()

def unload():
  es.msg('#Green', 'Sprint Script Off')

def es_map_start(event_var):
  loadblock()

def loadblock():
  if(es.exists("saycommand", "!sprint") != 1):
    es.regsaycmd('!sprint', 'xsprint/sprint')

def setspeed(userid, speed):
  es.setplayerprop(userid, "CBasePlayer.localdata.m_flLaggedMovementValue", speed)
  
def sprintmsg(userid, time, msg):
  if(time > lastroundtime):
    es.tell(userid, "#green", msg)

def round_start(event_var):
  global lastroundtime
  lastroundtime = int(time.time())
  global lastsprint
  lastsprint = {}

def sprint():
  global lastsprint
  sprint_userid = es.getcmduserid()
  sprint_steamid = es.getplayersteamid(sprint_userid)
  if(lastsprint == {}):
    lastsprint[sprint_steamid] = 0
  thesprinttime = int(time.time())
  if(thesprinttime > int(lastsprint[sprint_steamid])):
    global sprint_msgs
    global sprint_speed
    global sprint_time
    global sprint_cooldown
    if(sprint_msgs != 0):
      sprintmsg(sprint_userid, thesprinttime, "You are now using sprint.")
    setspeed(sprint_userid, sprint_speed)
    gamethread.delayed(sprint_time, setspeed, (sprint_userid, 1))
    if(sprint_msgs == 2):
      gamethread.delayed(sprint_time, sprintmsg, (sprint_userid, thesprinttime, "Your sprint has now ended."))
    lastsprint[sprint_steamid] = (thesprinttime + sprint_cooldown)
    if(sprint_msgs != 0):
      gamethread.delayed(sprint_cooldown, sprintmsg, (sprint_userid, thesprinttime, "You can now use sprint again."))